-- MySQL dump 10.9
--
-- Host: localhost    Database: ulogd
-- ------------------------------------------------------
-- Server version	4.1.12

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `connections`
--

DROP TABLE IF EXISTS `connections`;
CREATE TABLE `connections` (
  `ip_saddr` int(10) unsigned default NULL,
  `ip_daddr` int(10) unsigned default NULL,
  `sport` smallint(5) unsigned default NULL,
  `dport` smallint(5) unsigned default NULL,
  `connection_id` int(10) unsigned NOT NULL auto_increment,
  `num_packets` int(10) unsigned default '0',
  `open` enum('YES','NO') default 'YES',
  `protocol` tinyint(3) unsigned default NULL,
  `packet_ttl` float default '0',
  `packet_length` float default '0',
  `tcp_urg` int(10) unsigned default '0',
  `tcp_ack` int(10) unsigned default '0',
  `tcp_psh` int(10) unsigned default '0',
  `tcp_rst` int(10) unsigned default '0',
  `tcp_syn` int(10) unsigned default '0',
  `tcp_fin` int(10) unsigned default '0',
  `time_established` datetime default NULL,
  `time_closed` datetime default NULL,
  `time_last_packet` datetime default NULL,
  `score` float default NULL,
  `currently_scored` enum('YES','NO') default 'NO',
  PRIMARY KEY  (`connection_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `connections`
--


/*!40000 ALTER TABLE `connections` DISABLE KEYS */;
LOCK TABLES `connections` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `connections` ENABLE KEYS */;

--
-- Table structure for table `rules`
--

DROP TABLE IF EXISTS `rules`;
CREATE TABLE `rules` (
  `ip` int(10) unsigned NOT NULL default '0',
  `mask` tinyint(4) default NULL,
  `expiration` datetime default NULL,
  PRIMARY KEY  (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rules`
--


/*!40000 ALTER TABLE `rules` DISABLE KEYS */;
LOCK TABLES `rules` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `rules` ENABLE KEYS */;

--
-- Table structure for table `ulog`
--

DROP TABLE IF EXISTS `ulog`;
CREATE TABLE `ulog` (
  `raw_mac` varchar(80) default NULL,
  `oob_time_sec` int(10) unsigned default NULL,
  `oob_time_usec` int(10) unsigned default NULL,
  `oob_prefix` varchar(32) default NULL,
  `oob_mark` int(10) unsigned default NULL,
  `oob_in` varchar(32) default NULL,
  `oob_out` varchar(32) default NULL,
  `ip_saddr` int(10) unsigned default NULL,
  `ip_daddr` int(10) unsigned default NULL,
  `ip_protocol` tinyint(3) unsigned default NULL,
  `ip_tos` tinyint(3) unsigned default NULL,
  `ip_ttl` tinyint(3) unsigned default NULL,
  `ip_totlen` smallint(5) unsigned default NULL,
  `ip_ihl` tinyint(3) unsigned default NULL,
  `ip_csum` smallint(5) unsigned default NULL,
  `ip_id` smallint(5) unsigned default NULL,
  `ip_fragoff` smallint(5) unsigned default NULL,
  `tcp_sport` smallint(5) unsigned default NULL,
  `tcp_dport` smallint(5) unsigned default NULL,
  `tcp_seq` int(10) unsigned default NULL,
  `tcp_ackseq` int(10) unsigned default NULL,
  `tcp_window` smallint(5) unsigned default NULL,
  `tcp_urg` tinyint(4) default NULL,
  `tcp_urgp` smallint(5) unsigned default NULL,
  `tcp_ack` tinyint(4) default NULL,
  `tcp_psh` tinyint(4) default NULL,
  `tcp_rst` tinyint(4) default NULL,
  `tcp_syn` tinyint(4) default NULL,
  `tcp_fin` tinyint(4) default NULL,
  `udp_sport` smallint(5) unsigned default NULL,
  `udp_dport` smallint(5) unsigned default NULL,
  `udp_len` smallint(5) unsigned default NULL,
  `icmp_type` tinyint(3) unsigned default NULL,
  `icmp_code` tinyint(3) unsigned default NULL,
  `icmp_echoid` smallint(5) unsigned default NULL,
  `icmp_echoseq` smallint(5) unsigned default NULL,
  `icmp_gateway` int(10) unsigned default NULL,
  `icmp_fragmtu` smallint(5) unsigned default NULL,
  `pwsniff_user` varchar(30) default NULL,
  `pwsniff_pass` varchar(30) default NULL,
  `ahesp_spi` int(10) unsigned default NULL,
  `id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ulog`
--


/*!40000 ALTER TABLE `ulog` DISABLE KEYS */;
LOCK TABLES `ulog` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `ulog` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

